<?php

// -------- Variables -----------

define('DB_SERVER', 'localhost');
define('DB_NAME', 'socialmonitor');
define('DB_USERNAME', 'root');
define('DB_PASSWORD', 'root');

// -- -- -- -- -- -- -- -- -- --


$dataset = new CONECTA(DB_SERVER, DB_NAME, DB_USERNAME, DB_PASSWORD);


class CONECTA {

    var $prefijo = 'sm_';
    var $conn;

    public function __construct($db_server, $db_name, $db_user, $db_pas){
        $this->conn = mysqli_connect($db_server, $db_user, $db_pas, $db_name);
    }

    //-- -- -- Consulta Sencilla -- -- -- --//
    public function consulta_sencilla($tabla, $fields = '*'){
        $tabla = $this->prefijo.$tabla;
        $sql = "SELECT $fields FROM $tabla";
        $result = $this->sqlordie($sql);
        while($row = mysqli_fetch_object($result)) { $records[] = $row; }
        return $records;
    }

    // -- -- Consulta de Registros -- -- //
    public function consulta_general($tabla, $campo='', $criterio='', $campo2='', $criterio2='', $criterio_orden='', $orden='', $de='', $a='', $fields = '*'){ 
        $tabla = $this->prefijo.$tabla;
        $primer_criterio = '';
        if($campo !='' && $criterio !='') { $primer_criterio = " WHERE $campo = '$criterio'"; }
        $segundo_criterio = '';
        if($campo2 !='' && $criterio2 !='') { $segundo_criterio = " AND $campo2 = '$criterio2'"; }
        $ordenar = '';
        if($criterio_orden !='' && $orden !='') { $ordenar = " ORDER BY $criterio_orden $orden"; }
        $limites = '';
        if($de !='' && $a !='') { $limites = "LIMIT $de, $a"; } else { $limites = "LIMIT 0, 20"; }
        $sql = "SELECT $fields FROM $tabla $primer_criterio $segundo_criterio $ordenar $limites" ;
        // echo '<hr><pre>'.$sql.'</pre><hr>';
        $result = $this->sqlordie($sql);
        $records = '';
        while($row = mysqli_fetch_assoc($result)) { $records[0]['Code_JSON'] = 100; $records[] = $row; }
        if(!empty($records)){ return $records; } else { 
            $this->datos_error();
            $records[0]['Code_JSON'] = 200;
            return $records;
        }
    }

    // -- -- -- Consulta Fecha -- -- -- //
    public function consulta_fecha ($tabla, $campo_fecha, $fecha, $campo_criterio, $valor){
        $tabla = $this->prefijo.$tabla;
        $sql = "SELECT * FROM $tabla WHERE (CAST($campo_fecha AS DATE) = '$fecha') AND $campo_criterio = $valor";
        echo '<hr><pre>'.$sql.'</pre><hr>';
        $result = $this->sqlordie($sql);
        $records = '';
        while($row = mysqli_fetch_object($result)) { $records[] = $row; }
        if(!empty($records)){ return $records; } else { $this->datos_error(); }
    }

    // -- -- -- Consulta Entre Fechas -- -- -- //
    public function consulta_entre_fechas ($tabla, $campo_fecha, $fecha1, $fecha2, $campo_criterio, $valor){
        $tabla = $this->prefijo.$tabla;
        $sql = "SELECT * FROM $tabla WHERE $campo_fecha BETWEEN '$fecha1' AND '$fecha2' AND $campo_criterio = $valor";
        echo '<hr><pre>'.$sql.'</pre><hr>';
        $result = $this->sqlordie($sql);
        $records = '';
        while($row = mysqli_fetch_object($result)) { $records[] = $row; }
        if(!empty($records)){ return $records; } else { $this->datos_error(); }
    }


    // -- -- -- Consulta Unida -- -- -- -- --  //
    public function consulta_unida($tabla1, $tabla2, $campo1, $campo2, $criterio, $valor, $criterio2='', $valor2=''){
        $tabla1 = $this->prefijo.$tabla1;
        $tabla2 = $this->prefijo.$tabla2;
        $segundo_criterio = '';
        if($criterio2 !='' && $valor2 !='') { $segundo_criterio = "AND t2.$criterio2 = '$valor2'"; }
        $sql = "SELECT * FROM $tabla1 AS t1 INNER JOIN $tabla2 AS t2 ON t1.$campo1 = t2.$campo2 WHERE t1.$criterio = '$valor' $segundo_criterio" ;
       // echo '<hr><pre>'.$sql.'</pre><hr>';
        $result = $this->sqlordie($sql);
        $registros = '';
        while($row = mysqli_fetch_assoc($result)) {
            $registros[] = $row;
        }
        return $registros;
    }

    // -- -- Inserta -- -- //
    public function inserta_registro($tabla, $campos, $valores) {
        $tabla = $this->prefijo.$tabla;
        $sql = "INSERT INTO $tabla ($campos) VALUES ($valores)";
        echo $sql;
        $this->sqlordie($sql);
    }
    // -- -- //
    

    // -- -- Actualiza -- -- //
    public function update_array($tabla, $criterio, $valor, $Valores) {
        $tabla = $this->prefijo.$tabla;
        foreach($Valores as $key=>$value) {
            $sets[] = $key.'=\''.$value.'\'';
        }
        $sets = implode(',', $sets);
        $sql = "UPDATE $tabla SET $sets WHERE $criterio = '$valor'";
        echo '<hr><pre>'.$sql.'</pre><hr>';
        $this->sqlordie($sql);
    }
    // -- -- //

    //-- -------------------------------------- --//
    private function sqlordie($sql) {
        
        $return_result = $this->conn->query($sql);
        if($return_result) {
            return $return_result;
        } 
        else {
            $this->sql_error($sql);
        }
    }

    private function sql_error($sql) {
        //echo mysqli_error($this->conn).'<br>';
        //die('error: '. $sql);
        echo '{"Error":{"id":0,"Autor":"Rogelio Argumedo","Autor_Email":"rogelio@argumedo.mx","Estatus":"Error","Error_Tipo":"Error de SQL","Fecha":"'.date("Y-m-d H:i:s").'"}}';
       echo '<hr><pre>'.$sql.'</pre><hr>';
        die();
    }

    private function datos_error() {
       // echo '{"Error":{"id":0,"Autor":"Rogelio Argumedo","Autor_Email":"rogelio@argumedo.mx","Estatus":"Error","Error_Tipo":"No hay Datos","Fecha":"'.date("Y-m-d H:i:s").'"}}';
        //die();
    }

}
